#include<stdio.h>
#include<string.h>
#include "portScanner.h"
void *port_connect(void *thread_args) {
  //lock thread
  //rc_t = pthread_mutex_lock(&mutex);

  t_arg_array *t_args = (t_arg_array *)thread_args;

  char *t_ip_addr = t_args->ip;
  int *t_port = t_args->port;

  //fprintf(stdout, "Port Thread with IP[%s] and PORT[%d]\n", t_ip_addr, *(t_port));
  
  //int socketHandle;
  

  /* TIME TO CONNECT */
  if((TRANSPORT == 2) || (TRANSPORT == 0)) {
    struct sockaddr_in socket_address;
    int status, timer;
    int flags;
    int tcp_sHandle;
    int n = 0;
    char buffer[512];
    int statusConn = 0;
    char service[512];
    char version[512] ="";
    int serviceVerification =0;
    int violation =0;   
    	char servName[20];
    struct timeval timeout;
    
    timeout.tv_sec = 3;
    timeout.tv_usec = 0;
    
    tcp_sHandle = socket(PF_INET, SOCK_STREAM, 0);

    if(tcp_sHandle == -1) {
      printf("error with tcp_sHandle[%d]\n", tcp_sHandle);
      exit(1);
    }

    flags = fcntl(tcp_sHandle, F_GETFL, 0);
    fcntl(tcp_sHandle, F_SETFL, flags | O_NONBLOCK);
    
    fd_set readFDS, writeFDS;
    
    FD_ZERO(&readFDS);
    FD_ZERO(&writeFDS);
    FD_SET(tcp_sHandle, &writeFDS);
    FD_SET(tcp_sHandle, &readFDS);
    
    socket_address.sin_family = AF_INET;
    socket_address.sin_port = htons(*(t_port));
    socket_address.sin_addr.s_addr = inet_addr(t_ip_addr);
    
    status = connect(tcp_sHandle, 
		     (struct sockaddr *)&socket_address,
		     sizeof(socket_address));

    flags = fcntl(tcp_sHandle, F_GETFL, 0);
    fcntl(tcp_sHandle, F_SETFL, flags & ~O_NONBLOCK);

    timer = select(tcp_sHandle+1, &readFDS, &writeFDS, NULL, &timeout);

    int data;
    socklen_t optlen = sizeof(data);

    //call getsockopt
    getsockopt(tcp_sHandle, SOL_SOCKET, SO_ERROR, (void *)&data, &optlen);

    //printf("valopt: %d\n", data);

    if(timer == 0) {
      //fprintf(stdout, "%15s:%-4d [%s]\t\t%s\n", t_ip_addr, *(t_port), "CLOSED | FILTERED", "TCP");
      /*
      if(NUM_THREADS) {
	pthread_exit(NULL);
      }
      */
      close(tcp_sHandle);
    } else {
      if(data == 0) {
	//get service for port

	char nodeName[1024];
	socklen_t nodeNameLen = sizeof(nodeName);
	socklen_t servNameLen = sizeof(servName);
	
	getnameinfo((struct sockaddr *)&socket_address,
		    sizeof(socket_address),
		    nodeName, nodeNameLen,
		    servName, servNameLen, 0);
	/*
	struct servent port_service;
	port_service = getservbyport(*(t_port), "tcp");
	*/
	//printf("serv %s\n", servName);


	if((*(t_port) == 22) || 
	   (*(t_port) == 25) || 
	   (*(t_port) == 43) || 
	   (*(t_port) == 80) ||
	   (*(t_port) == 110) ||
	   (*(t_port) == 143)) {
	  if((*(t_port) == 22) ||
	     (*(t_port) == 25) || 
	     (*(t_port) == 110) ||
	     (*(t_port) == 143)) {

    FD_ZERO(&readFDS);
    FD_SET(tcp_sHandle, &readFDS);

	 timeout.tv_sec = 3;
    timeout.tv_usec = 0;
		    timer = select(tcp_sHandle+1, &readFDS, NULL, NULL, &timeout);
	if(timer == 0){
		serviceVerification = 0;
		goto tcpPrintStatement;
	
			}	   

 n = read(tcp_sHandle, buffer, sizeof(buffer));



		


	    buffer[n] = '\0';
	    //printf("BUFFER : %s ", buffer);

	    switch(*(t_port)){
	    case 22 :{
	      char * token;
	      int count = 0; //just to check what position we are in
		if(strstr(buffer,"\n") != NULL){  //check to see that CR LF is in the SSH greeting SSH-protoversion-softwareversion SP comments CR LF
	  
			serviceVerification = 1;		
		}else{
		serviceVerification = 0;
		goto tcpPrintStatement;
		}

			    token = strtok(buffer,"-");
	      while (token != NULL){
		if (count ==0){//check to see if the first token is 'SSH' else, this is in violation
		  if(strcmp(token,"SSH")==0){
		    serviceVerification = 1;
		  }else{
		    serviceVerification = 0;
		  }
		}
		if (count == 2){//the service version should be here
		  strcpy(version,	token);
		}
		count = count +1;
		token = strtok(NULL,"-");
	      }
	      if (serviceVerification == 1){
		//printf("verified service");
		//printf("Version : %s",version);

////		fprintf(stdout, "%15s:%-4d [%s]\t\t%s\t%s\t\t%s\n", t_ip_addr, *(t_port), "OPEN", "TCP", servName, version);
	      }else{
////		fprintf(stdout, "%15s:%-4d [%s]\t\t%s\t%s\t\t%s\n", t_ip_addr, *(t_port), "OPEN", "TCP", servName, "Unverified");
		//printf("Service though listening, is not verified");
	      }	
	      //we expect here based on RFC 4253 the following template for SSH SSH-protoversion-softwareversion SP comments CR LF, so we will parse accordinly	
	 //     break;
	   goto tcpPrintStatement; }
	    case 25:{
	      
	      char *token = malloc(sizeof(buffer));
	      strcpy(version,"");
	      int count = 0; //just to check what position we are in
	      token = strtok(buffer," "); //according to RFC the space seperates the letter 
	      while (token != NULL){
		if (count ==0){//check to see if the first token is '220' or '554' else, this is in violation
		  if(strcmp(token,"220")==0||strcmp(token,"554" ==0)){
		    serviceVerification = 1;
		  }else{
		    serviceVerification = 0;
		  }
		}
		else if (count >=2){//the service version should be here POSSIBLE
//			if (strcmp((const char )(token[strlen(token)-1]),"\n") ==0)
	//			token = left(token,strlen(token)-1);
		  strcat(version,	token);
		strcat(version, " ");
		}else if (count ==4){
		  break; //too much information
		}
		count = count +1;
		token = strtok(NULL," ");
	      }
	      if (serviceVerification == 1){

	////	fprintf(stdout, "%15s:%-4d [%s]\t\t%s\t%s\t\t%s\n", t_ip_addr, *(t_port), "OPEN", "TCP", servName, version);
		//printf(stdout, "%15s:%-4d [%s]\t\t%s\t%s\n", t_ip_addr, *(t_port), "OPEN", "TCP", version);
	      }else{
		//printf("Service though listening, is not verified");
	////	fprintf(stdout, "%15s:%-4d [%s]\t\t%s\t%s\t\t%s\n", t_ip_addr, *(t_port), "OPEN", "TCP", servName, "Unverified");
		//fprintf(stdout, "%15s:%-4d [%s]\t\t%s\t%s\n", t_ip_addr, *(t_port), "OPEN", "TCP", "Unverified");
	      }	
	      //we expect here based on RFC 4253 the following template for SSH SSH-protoversion-softwareversion SP comments CR LF, so we will parse accordinly	
	     // break;
		goto tcpPrintStatement;}
	      
	    case 110:{

	      char * token;
	      strcpy(version,"");
	      int count = 0; //just to check what position we are in

			if(strstr(buffer,"\n") != NULL){  //check to see that CR LF is in the POP response
	  
				serviceVerification = 1;		
			}else{
			serviceVerification = 0;
			goto tcpPrintStatement;
			}



	      token = strtok(buffer," "); //according to RFC the space seperates the letter 

	      while (token != NULL){


		if (count ==0){//check to see if the first token is '+OK' or "-ERR" as per mandate else, this is in violation
		  if(strcmp(token,"+OK")==0 ||strcmp(token,"-ERR" ==0)){
		    serviceVerification = 1;
		  }else{
		    serviceVerification = 0;
		  }
		}
		else if (count >= 1 ){//the service version should be here POSSIBLE
	//	printf("%s",token);
		  strcat(version,	token);
			 strcat(version,	" ");
		}else if (count ==4){
		  break; //too much information
		}
		count = count +1;
		token = strtok(NULL," ");
	      }
	      if (serviceVerification == 1){
		//printf("verified service");
//		/printf("Versioni-----------------> : %s",version);
////		fprintf(stdout, "%15s:%-4d [%s]\t\t%s\t%s\t\t%s\n", t_ip_addr, *(t_port), "OPEN", "TCP", servName, version);
		//fprintf(stdout, "%15s:%-4d [%s]\t\t%s\t%s\n", t_ip_addr, *(t_port), "OPEN", "TCP", version);
	      }else{
		//printf("Service though listening, is not verified");
////		fprintf(stdout, "%15s:%-4d [%s]\t\t%s\t%s\t\t%s\n", t_ip_addr, *(t_port), "OPEN", "TCP", servName, "Unverified");
		//fprintf(stdout, "%15s:%-4d [%s]\t\t%s\t%s\n", t_ip_addr, *(t_port), "OPEN", "TCP", "Unverified");
		break; }
	   goto tcpPrintStatement; }
	    case 143:{

	      char * token;
	      strcpy(version,"");
	      int count = 0; //just to check what position we are in
			if(strstr(buffer,"\n") != NULL){  //check to see that CR LF is in the IMAP response
	  
			serviceVerification = 1;		
		}else{
		serviceVerification = 0;
		goto tcpPrintStatement;
		}


	      token = strtok(buffer," "); //according to RFC the space seperates the letter 
	      while (token != NULL){
		if (count ==0){
		  if(strcmp(token,"*") == 0){
		    serviceVerification =1;
		  }else{
		    serviceVerification =0;
		    break;
		  }
		}
		if (count ==1){//check to see if the first token is 'OK' , 'NO', or 'BAD' else, this is in violation
		  if(strcmp(token,"OK")==0||strcmp(token,"NO" ==0)|| strcmp(token,"BAD")==0){
		    serviceVerification = 1;
		  }else{
		    serviceVerification = 0;
		    break;
		  }
		}
		else if (count >=2){//the service version should be here POSSIBLE
		  strcat(version,	token);
			strcat(version, " ");
		}else if (count ==4){
		  break; //too much information
		}
		count = count +1;
		token = strtok(NULL," ");
	      }

goto tcpPrintStatement;
	    }
	      
default:break;
	      
	    }	//end switch			
	    
	    if (n < 0){
	      diep("read()");
	    }
	  }
	  else if((*(t_port) == 43) ||
		  (*(t_port) == 80)) {
	    char sendBuffer[400];
	    char recvBuffer[500];
	    
	    if(*(t_port) == 43) {

	      char request[] = "dummyuser.net\r\n";            
	      
	      //we don't need this for ssh,imap,pop3,smtp,

	      statusConn = send(tcp_sHandle,
				request,
				(int)sizeof(request),
				0);  

	      if(statusConn < 0) {
		printf("nothing can be snt\n");
	      }
	      
	      int rec = 1;
	      while (rec > 0) {
		if (rec < 0){
		  printf("error in receive test");
		  diep("recv()");
		}

 
    FD_ZERO(&readFDS);
    FD_SET(tcp_sHandle, &readFDS);

	 timeout.tv_sec = 10;
    timeout.tv_usec = 0;
		    timer = select(tcp_sHandle+1, &readFDS, NULL, NULL, &timeout);
	if(timer == 0){
					serviceVerification = 0 ;
	
						goto tcpPrintStatement;
}


		rec = recv(tcp_sHandle, recvBuffer, sizeof(recvBuffer), 0);
		if (rec > 0) {


		if(strstr(recvBuffer,"\n") != NULL){  //check to see that CR LF is in the response
	  
			serviceVerification = 1;		
		}else{
		serviceVerification = 0;
		goto tcpPrintStatement;
		}


		  // null terminate the buffer so that we can print it
		  recvBuffer[rec] = '\0';
		  serviceVerification = 1;
			strcpy(version, "verified, but no version information available");
			goto tcpPrintStatement;
		  // output response
	//	  printf("%s", recvBuffer);
		}
	      }		
////	      fprintf(stdout, "%15s:%-4d [%s]\t\t%s\t%s\t\t%s\n", t_ip_addr, *(t_port), "OPEN", "TCP", servName, "vers");
	      //fprintf(stdout, "%15s:%-4d [%s]\t\t%s\n", t_ip_addr, *(t_port), "OPEN", "TCP");
	    }else if(*(t_port) == 80) {

	      char request[512] ;
	      

	      strcat(request, "HEAD / HTTP/1.1\r\nHOST:");
	      strcat(request,t_ip_addr);
	      strcat(request,"\r\n\r\n");   
	    //  printf("request is %s",request); 
	      //we don't need this for ssh,imap,pop3,smtp,

	      statusConn = send(tcp_sHandle,
				request,
				(int)sizeof(request),
				0);  
    
	      if (statusConn < 0){
		printf("nothing can be snt\n");
	      }
	      
	      int rec = 1;
			  strcpy(version,"");	
int countrecv = 0;
    FD_ZERO(&readFDS);
    FD_SET(tcp_sHandle, &readFDS);

	 timeout.tv_sec = 60;
    timeout.tv_usec = 0;
		    timer = select(tcp_sHandle+1, &readFDS, NULL, NULL, &timeout);
	if(timer == 0){
					serviceVerification =0;
					goto tcpPrintStatement;
}

		rec = recv(tcp_sHandle, recvBuffer, sizeof(recvBuffer), 0);
      while (rec > 0) {
		if (rec < 0){
		  printf("error in receive test");
		  diep("recv()");
		}
countrecv++;
////////////set timeer here
   

////////////




		
		if (rec > 0) {
		  // null terminate the buffer so that we can print it
		  recvBuffer[rec] = '\0';
		  
		  // output response
		//  printf("%s", recvBuffer);






		  char * token;
	
		  int count = 0; //just to check what position we are in
		  token = strtok(recvBuffer,"\n"); //according to RFC the space seperates the letter 
		  while (token != NULL){
			
		 if (count ==0){
		
		  if(strstr(token,"HTTP/1") != NULL){
	
			serviceVerification =1;
		      }else{
			serviceVerification =0;
			break;
		      }
		    }
		    if (strstr(token,"Server:")){//check to see if the first token is Server else, this is in violation
			
	   //   printf("string is %s\n",token);
		      strcpy(version,	token);
			token = strtok(token,":");
			token = strtok(NULL,":");
			strcpy(version,token);
			break;
		    }
		    if (count ==10){
		      break; //too much information
		      // do your validation here
		    }
		    count = count +1;
		    token = strtok(NULL,"\n");
		  }
		  
		}
    FD_ZERO(&readFDS);
    FD_SET(tcp_sHandle, &readFDS);

	 timeout.tv_sec = 3;
    timeout.tv_usec = 0;
		    timer = select(tcp_sHandle+1, &readFDS, NULL, NULL, &timeout);
	if(timer == 0){break;
}
rec = recv(tcp_sHandle, recvBuffer, sizeof(recvBuffer), 0);
if(countrecv >10)
	break;
	      }




	////      fprintf(stdout, "%15s:%-4d [%s]\t\t%s\t%s\t\t%s\n", t_ip_addr, *(t_port), "OPEN", "TCP", servName, version);
	//	printf("version00000: %s",version);
	      //fprintf(stdout, "%15s:%-4d [%s]\t\t%s\n", t_ip_addr, *(t_port), "OPEN", "TCP");
	    }
	  }


////output

	tcpPrintStatement:      if (serviceVerification == 1){
		//printf("verified service");
		//printf("Version : %s",version);
		char* c = strchr(version,'\n');
		if (c  != NULL){
			strncpy(version,version, c- version +1);
		}
			 c = strchr(version,'\r');
		if (c  != NULL){
			strncpy(version,version, c- version +1);
		}

		fprintf(stdout, "%15s:%-4d [%s]\t\t%s\t%s\t\t%s\n", t_ip_addr, *(t_port), "OPEN", "TCP", servName, version);
		//fprintf(stdout, "%15s:%-4d [%s]\t\t%s\t%s\n", t_ip_addr, *(t_port), "OPEN", "TCP", version);
	      }else{
		//printf("Service though listening, is not verified");
		fprintf(stdout, "%15s:%-4d [%s]\t\t%s\t%s\t\t%s\n", t_ip_addr, *(t_port), "OPEN", "TCP", servName, "Unverified");
		//fprintf(stdout, "%15s:%-4d [%s]\t\t%s\t%s\n", t_ip_addr, *(t_port), "OPEN", "TCP", "Unverified");
		//break;
	      }


	}// port verification
	 else {
	  fprintf(stdout, "%15s:%-4d [%s]\t\t%s\t%s\n", t_ip_addr, *(t_port), "OPEN", "TCP", servName);
	  //fprintf(stdout, "%15s:%-4d [%s]\t\t%s\n", t_ip_addr, *(t_port), "OPEN", "TCP");
	}
      }





      close(tcp_sHandle);
    }
  }

  /* UDP CONNECT */
  udpcheck: if((TRANSPORT == 2) || (TRANSPORT == 1)) {
    //printf("port3 %d\n", *(t_port));    
    struct sockaddr_in socketAddress,clientSocketAddress;
    int status, statusRecv;
    int statusUDPConnect = 0;
    int statusSendTo = 0;
    int udp_sHandle;
    //printf("port1 %d\n", *(t_port));
    memset(socketAddress.sin_zero, '\0', sizeof(socketAddress.sin_zero));
    memset(clientSocketAddress.sin_zero, '\0', sizeof(clientSocketAddress.sin_zero));

    socketAddress.sin_family = AF_INET;
    socketAddress.sin_port = htons(*(t_port));
    socketAddress.sin_addr.s_addr = inet_addr(t_ip_addr);
    //printf("port2 %d\n", *(t_port));    
    clientSocketAddress.sin_family = AF_INET;
    clientSocketAddress.sin_port = htons(0);
    clientSocketAddress.sin_addr.s_addr = inet_addr("127.0.0.1");
    
    fd_set readFDS;
    struct timeval timeout;
    timeout.tv_sec = 3;
    timeout.tv_usec = 0;

    udp_sHandle = socket(PF_INET,SOCK_DGRAM,IPPROTO_UDP);
    if(udp_sHandle == -1) {
      printf("error with udp_sHandle[%d]\n", udp_sHandle);
		 close(udp_sHandle);		
		return 0;    
		//  exit(1);
    }

    char *buffer = (char *)malloc(sizeof(char));

    FD_ZERO(&readFDS);
    FD_SET(udp_sHandle,&readFDS);    
    
    statusUDPConnect = connect(udp_sHandle,
			       (struct sockaddr *)&socketAddress,
			       sizeof(socketAddress));
    
    if(statusUDPConnect < 0) {
		 close(udp_sHandle);
		return 0;
    //  diep("udpconnect()");
    }
    
    statusSendTo = sendto(udp_sHandle,
			  "pingme",
			  sizeof("pingme"),
			  0,
			  (struct sockaddr *)&socketAddress,
			  sizeof(socketAddress));
    
    if(statusSendTo < 0) {
 close(udp_sHandle);	
return 0;    

//  diep("sendto()");
    }
    

//get port service name 


	char servName[20];
	char nodeName[1024];
	socklen_t nodeNameLen = sizeof(nodeName);
	socklen_t servNameLen = sizeof(servName);
	
	getnameinfo((struct sockaddr *)&socketAddress,
		    sizeof(socketAddress),
		    nodeName, nodeNameLen,
		    servName, servNameLen, 0);


    //a timer here is necessary in case the host does not reply where we assume 
    //that the port is either open or filtered

  timeout.tv_sec = 10;
    timeout.tv_usec = 0;
int timer;
    timer = select(udp_sHandle+1, &readFDS, NULL, NULL, &timeout);
    if(timer ==0) {
      fprintf(stdout, "%15s:%-4d [%s]\t%s\t%s\n", t_ip_addr, *(t_port), "OPEN | FILTERED", "UDP",servName);
      close(udp_sHandle);
      //printf("port %d open|filtered\n", *(t_port));
      //return 0;
    }
  
    int rc = 1;
    
    //while (rc > 0) {
    if(rc = recvfrom(udp_sHandle,buffer,(int)sizeof(buffer), 0, NULL,NULL)) {
      if(rc < 0) {
	//check what the error is if it is a connection refused error then
	//the port is closed, else if it is a system related error, exit the block
	if(errno ==ECONNREFUSED) {
	  //printf("port %d closed\n", *(t_port));
 close(udp_sHandle);	
	return 0;
	} else {
		 close(udp_sHandle);
		return 0;
	  diep("recvfrom()");
	}
	//return 0;
      }
    }    
    
    if(rc > 0) {
      // null terminate the buffer so that we can print it
      buffer[rc] = '\0';
      
      // output response
      //	printf("%s", buffer);
      //printf("port %d open\n", *(t_port));
      fprintf(stdout, "%15s:%-4d [%s]\t\t%s\t\%s\n", t_ip_addr, *(t_port), "OPEN", "UDP",servName);
      //return 1;
    }		
    
    //return 1;	
    //free(readFDS);
    close(udp_sHandle);
  } //end udp handling 

  return;
}
