
#include<stdio.h>
#include<string.h>
#include "portScanner.h"
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>

void *port_flag_scan(void *thread_args){
	char *recv_buffer;
	//int i=0;
	int flag_resp[5];
	if(IS_IDLE_SET) {
		idle_scan((void *)thread_args);
	} else if(IS_DECOY_SET) {
		decoy_scan((void *)thread_args);
	} else {
		for (i=0 ;i < 5; i++){
			flag_resp[i] = -1;
			if ((mode_flags) & (1<<i)){
				//printf("Test");
				generic_port_flag_scan((void*)thread_args,&recv_buffer,0,NULL,i+1);
				if(recv_buffer != NULL){
				flag_resp[i]=	parse_buffer(recv_buffer, (1 << i));
				}else{
					parse_timeout((void*)thread_args,(1<<i));
					flag_resp[i] =-1;
				}

			}
		}
			if(mode_flags != 1 && mode_flags != 2 && mode_flags != 4 && mode_flags != 8 && mode_flags != 16)
				port_flag_scan_summary(flag_resp);
	}
}

int generic_port_flag_scan(void *thread_args, char ** recv_buffer, int is_spoof, char * spoof_addr,int flag){
	sleep(0.1);
	t_arg_array *t_args = (t_arg_array *)thread_args;

	char *t_ip_addr = t_args->ip;
	int *t_port = t_args->port;
	char *packet_buffer; 
	packet_buffer =  (char *)malloc((size_t)MAX_PACKET_SIZE);
	struct sockaddr_in  socket_address;
	socket_address.sin_family = AF_INET;
	socket_address.sin_port = htons(*(t_port));
	socket_address.sin_addr.s_addr = inet_addr(t_ip_addr);

	int raw_sock_handle;
	raw_sock_handle = socket (PF_INET, SOCK_RAW, IPPROTO_TCP);
	if (raw_sock_handle < 0){
		diep("socket creation error");
		exit(1);
	}
	struct ip *ip_hdr = (struct ip *) packet_buffer;
	struct tcphdr  *tcp_hdr = (struct tcphdr *) (packet_buffer + sizeof(struct ip)) ;
	memset(packet_buffer,0, MAX_PACKET_SIZE); //reset the buffer memory

	ip_hdr->ip_hl = 5; //set ip header length to 20 bytes
	ip_hdr->ip_v = 4; //set the version to 4
	ip_hdr->ip_tos = 0;
	ip_hdr->ip_off = 0; //fragmentation not acceptable
	ip_hdr->ip_p = 6; //set protocol to tcp
	ip_hdr->ip_ttl = 32;
	ip_hdr->ip_id = htons(rand());
	char * src_ip_addr ;
	src_ip_addr = malloc(15*sizeof(char *));

	if(!is_spoof){
		strcpy(src_ip_addr, get_this_ipaddr(raw_sock_handle,t_ip_addr));
	}
	else{
		strcpy(src_ip_addr,spoof_addr);
	}
	ip_hdr->ip_src.s_addr = inet_addr (src_ip_addr);
	ip_hdr->ip_dst.s_addr = inet_addr(t_ip_addr);

	tcp_hdr->source = htons(gen_random_number(1025,65535));
	tcp_hdr->dest = htons(*(t_port));

	ip_hdr->ip_len =htons((sizeof (struct ip) + sizeof (struct tcphdr)));
	//htons(MAX_PACKET_SIZE); 
	//sizeof(struct ip) + sizeof(struct tcphdr);	

	tcp_hdr->seq = htonl(gen_random_number(0,0xfffffffe));



	tcp_hdr->res1 =0;
	tcp_hdr->doff =5;
	tcp_hdr->fin =0;
	tcp_hdr->syn =0;
	tcp_hdr->rst =0;
	tcp_hdr->psh =0;
	tcp_hdr->ack =0;
	tcp_hdr->urg =0;
	tcp_hdr->res2 =0;
	tcp_hdr->window = htons(32768);
	tcp_hdr->check =0;

	switch(flag){
		case 1: //SYN scan flag set
			tcp_hdr->syn =1;
			break;
		case 2: //ACK scan flag set
			tcp_hdr->ack=1;
			break;
		case 3: //FIN scan flag set
			tcp_hdr->fin=1;
			break;
		case 4://NULL scan do nothing
			break;
		case 5: //XMAS flag set
			tcp_hdr->fin =1;
			tcp_hdr->urg =1;
			tcp_hdr->psh =1;
			tcp_hdr->seq = 0;
			break;



	}


	ip_hdr->ip_sum = htons((cksum((u_short *) packet_buffer, ip_hdr->ip_hl*4 >> 1))); //

	//printf("\n\n\nHE IP CHECKSUM IS    %x\n\n\n\n",ip_hdr->ip_sum);	


	//printf("size pckt %d\n\n",ip_hdr->ip_len);
	u_short *dgram = (u_short *)packet_buffer;
	//printf("datagram is ");
	int i =0;
	for(i=0; i< 40; i++){

		//	printf("%x",*(dgram++));
	}
	//printf("\n");

	tcp_hdr->check = ntohs(in_cksum_tcp((char *)packet_buffer));
	//	get_this_ipaddr(raw_sock_handle);
	int sm=1460;
	const int *val=&sm;
	setsockopt(raw_sock_handle, IPPROTO_IP, IP_HDRINCL, val, sizeof(sm)); 
	// setsockopt (raw_sock_handle, IPPROTO_SCTP,1460 , val,
	//                  sizeof(sm));



	if( sendto(raw_sock_handle, (char *) packet_buffer,(size_t)htons(ip_hdr->ip_len),0, (struct sockaddr *)&socket_address, (size_t)sizeof(socket_address))< 0){
		diep("sendto error");
	};
	//set up the timer

	//set up the timer


	int timer;
	int breakFlag =0;
	fd_set readFDS, writeFDS;
	*recv_buffer = malloc(1024*(sizeof (char *)));
	memset(*recv_buffer,0,1024);


	struct timeval timeout;
	timeout.tv_sec = 3;
	timeout.tv_usec = 0;




	//end setup the timer

	//printf("socket is %d", raw_sock_handle);
	*recv_buffer = malloc(1024*(sizeof (char *)));
	memset(*recv_buffer,0,1024);

	struct ip *recv_ip_hdr;
	struct tcphdr *recv_tcp_hdr;


if(!is_spoof){


	while(1){

		FD_ZERO(&readFDS);


		FD_SET(raw_sock_handle,&readFDS);


		if(timer = select(raw_sock_handle+1, &readFDS, NULL, NULL, &timeout) < 0){
			diep("select");

		}

		if (FD_ISSET(raw_sock_handle,&readFDS)){
		}else{

			*recv_buffer = NULL;
			close(raw_sock_handle);
			return 0;


		}


		if(recvfrom(raw_sock_handle, *recv_buffer, 1024, 0,//flags
					NULL, NULL) < 0){
			diep("recvfrom error:");
		}
		recv_ip_hdr = (struct ip *) *recv_buffer;
		recv_tcp_hdr = (struct tcphdr *)(*recv_buffer + sizeof(struct ip));
		if((ip_hdr->ip_dst.s_addr == recv_ip_hdr->ip_src.s_addr) && (ntohs(tcp_hdr->dest) == ntohs(recv_tcp_hdr->source))){
			recv_buffer[1024] = '\0';
			break;
		}

	}
	}//end if 
	close(raw_sock_handle);

}

