#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <pthread.h>
#include <netdb.h>
#include <time.h>
#include <sys/select.h>
#include <sys/socket.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <unistd.h>
#include <errno.h>
#include <fcntl.h>
#include <math.h>
#include <netinet/tcp.h>
#include <netinet/ip.h>

#define MAX_PORTS 1024
#define MAX_IP_ADDRS 0xFFFF
#define WAIT_TIME 5
#define IS_BIT_SET(x,n) (((x)&(1<<n))?1:0)
#define SET_BIT(x,n) ((x)|(1<<n))
#define UNSET_BIT(x,n) ((x)&~(1<<n))
#define DECOY_SCANS 10
#define IDLE_SCANS 10
#define MAX_PACKET_SIZE 1024
extern pthread_cond_t t_start ;
extern  pthread_mutex_t mutex ;
//Accumulators
extern unsigned int i ;
extern unsigned int j ;

extern FILE *file ;


extern struct timeval now;
extern struct timespec offset;

extern u_char flags;
extern int  PORTS[MAX_PORTS];
extern int NUM_PORTS ;
extern char *IP_ADDRS[MAX_IP_ADDRS];
extern int NUM_IP_ADDRS ;
extern char *IP_ADDR ;
extern char *IP_PREFIX ;
extern int PREFIX_LENGTH ;
extern char *FILE_NAME ;
extern int TRANSPORT ; //0 for TCP, 1 for UDP, 2 for both (default)
extern int NUM_THREADS ;
extern int IS_FLAG_SET;
extern int IS_IDLE_SET;
extern int IS_DECOY_SET;
extern int MAX_DECOY_SCANS;
extern char *decoy_ip_addrs[DECOY_SCANS];
extern int MAX_IDLE_SCANS;
extern char *idle_ip_addrs[IDLE_SCANS];
extern u_char mode_flags;
typedef struct {
  char *ip;
  int *port;
} t_arg_array;

void diep(char *);

void parse_timeout(void*,int);

void displayHelp(void);

 
unsigned int endian_switch(unsigned int );
 
unsigned int gen_random_number(unsigned int ,unsigned  int ) ;


void build_ports(void);

void build_prefix(void);
int main(int,char**);
void* port_connect(void *);
void* ip_scan(void *);
void diep (char *);
void conquer(void);
void *port_flag_scan(void *);
char* get_this_ipaddr(int,char * );
u_short cksum(u_short *, int);
unsigned short in_cksum_tcp(char *);
int generic_port_flag_scan(void *,char **, int, char *,int);
int parse_buffer(char *, int);
void port_flag_scan_summary(int[]);
